# How Do I Install Native Xen and KVM Drivers?

#### Scenarios

When optimizing a Linux private image, you need to install native Xen and KVM drivers for the image.

If you do not install Xen drivers for the image, the network performance of the ECSs created from this image will be poor, and the security groups and firewall configured for the ECSs will not take effect.

If you do not install KVM drivers for the image, the NICs of the ECSs may not be detected and the ECSs will be unable to communicate with other resources.

This section describes how to install native Xen and KVM drivers.

#### Prerequisites

- The kernel version must be later than 2.6.24.
- Antivirus and intrusion detection software have been disabled. You can enable them after Xen and KVM drivers are installed.

#### Procedure

Modify the configuration file depending on the OS.

- CentOS, EulerOS

  Take CentOS 7.0 as an example. Modify the /etc/dracut.conf file. Add the xen-pv and VirtIO drivers to add_drivers. xen-pv drivers include xen-blkfront and xen-netfront. VirtIO drivers include virtio_blk, virtio_scsi, virtio_net, virtio_pci, virtio_ring, and virtio. Separate driver names with spaces. Save and exit the /etc/dracut.conf file. Run the dracut -f command to regenerate initrd.

  For details, see CentOS and EulerOS.

- Ubuntu and Debian

  Modify the /etc/initramfs-tools/modules file. Add the xen-pv and VirtIO drivers. xen-pv drivers include xen-blkfront and xen-netfront. VirtIO drivers include virtio_blk, virtio_scsi, virtio_net, virtio_pci, virtio_ring, and virtio. Separate driver names with spaces. Save and exit the /etc/initramfs-tools/modules file. Run the update-initramfs -u command to regenerate initrd.

  For details, see Ubuntu and Debian.

- SUSE and openSUSE
  - If the OS version is earlier than SUSE 12 SP1 or openSUSE 13, modify the /etc/sysconfig/kernel file and add xen-pv and VirtIO drivers to INITRD_MODULES="". xen-pv drivers include xen_vnif, xen_vbd, and xen_platform_pci. VirtIO drivers include virtio_blk, virtio_scsi, virtio_net, virtio_pci, virtio_ring, and virtio. Separate driver names with spaces. Run the mkinitrd command to regenerate initrd.
  - If the OS version is SUSE 12 SP1, modify the /etc/dracut.conf file and add xen-pv and VirtIO drivers to add_drivers. xen-pv drivers include xen_vnif, xen_vbd, and xen_platform_pci. VirtIO drivers include virtio_blk, virtio_scsi, virtio_net, virtio_pci, virtio_ring, and virtio. Separate driver names with spaces. Run the dracut -f command to regenerate initrd.
  - If the OS version is later than SUSE 12 SP1 or openSUSE 13, modify the /etc/dracut.conf file and add xen-pv and VirtIO drivers to add_drivers. xen-pv drivers include xen-blkfront and xen-netfront. VirtIO drivers include virtio_blk, virtio_scsi, virtio_net, virtio_pci, virtio_ring, and virtio. Separate driver names with spaces. Save and exit the /etc/dracut.conf file. Run the dracut -f command to regenerate initrd.
  For details, see SUSE and openSUSE.

  For SUSE, run the following command to check whether xen-kmp (driver package for xen-pv) is installed:

  rpm -qa |grep xen-kmp

  If information similar to the following is displayed, xen-kmp is installed in the OS:

      xen-kmp-default-4.2.2_04_3.0.76_0.11-0.7.5

  If xen-kmp is not installed, obtain it from the ISO file and install it.

  If you add built-in drivers to the initrd or initramfs file by mistake, the ECS will not be affected.

#### CentOS and EulerOS

1. Run the following command to open the /etc/dracut.conf file:

   vi /etc/dracut.conf

2. Press i to enter editing mode and add the xen-pv and VirtIO drivers to add_drivers (the format varies depending on the OS).

       [root@CTU10000xxxxx ~]# vi /etc/dracut.conf
       # additional kernel modules to the default
       add_drivers+="xen-blkfront xen-netfront virtio_blk virtio_scsi virtio_net virtio_pci virtio_ring virtio"
       ......

3. Press Esc, enter :wq, and press Enter. The system saves the change and exits the /etc/dracut.conf file.
4. Run the following command to regenerate initrd:

   dracut -f /boot/initramfs-2.6.32-573.8.1.el6.x86_64.img

   If the virtual file system is not the default initramfs, run the dracut -f Name of the initramfs or initrd file actually used command. The actual initramfs or initrd file name can be obtained from the grub.cfg file, which can be /boot/grub/grub.cfg, /boot/grub2/grub.cfg, or /boot/grub/grub.conf depending on the OS.

5. If the virtual file system is initramfs, run the following commands to check whether native Xen and KVM drivers have been loaded:

   lsinitrd /boot/initramfs-`uname -r`.img | grep xen

   lsinitrd /boot/initramfs-`uname -r`.img | grep virtio

   If the virtual file system is initrd, run the following commands to check whether native Xen and KVM drivers have been loaded:

   lsinitrd /boot/initrd-`uname -r` | grep xen

   lsinitrd /boot/initrd-`uname -r` | grep virtio

   Assume that the virtual file system is initramfs. The following command output will be displayed:

       [root@CTU10000xxxxx home]# lsinitrd /boot/initramfs-`uname -r`.img | grep xen
       -rwxr--r--   1 root     root        54888 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/block/xen-blkfront.ko
       -rwxr--r--   1 root     root        45664 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/net/xen-netfront.ko

       [root@CTU10000xxxxx home]# lsinitrd /boot/initramfs-`uname -r`.img | grep virtio
       -rwxr--r--   1 root     root        23448 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/block/virtio_blk.ko
       -rwxr--r--   1 root     root        50704 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/net/virtio_net.ko
       -rwxr--r--   1 root     root        28424 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/scsi/virtio_scsi.ko
       drwxr-xr-x   2 root     root            0 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/virtio
       -rwxr--r--   1 root     root        14544 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/virtio/virtio.ko
       -rwxr--r--   1 root     root        21040 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/virtio/virtio_pci.ko
       -rwxr--r--   1 root     root        18016 Jul 16 17:53 lib/modules/2.6.32-573.8.1.el6.x86_64/kernel/drivers/virtio/virtio_ring.ko

   If you add built-in drivers to the initrd or initramfs file, the ECS will not be affected. This makes it easy to modify the drivers. However, you cannot check the drivers by running the lsinitrd command. You can run the following commands to check whether built-in drivers are in the kernel:

   cat /boot/config-`uname -r` | grep CONFIG_VIRTIO | grep y

   cat /boot/config-`uname -r` | grep CONFIG_XEN | grep y

#### Ubuntu and Debian

1. Run the following command to open the modules file:

   vi /etc/initramfs-tools/modules

2. Press i to enter editing mode and add the xen-pv and VirtIO drivers to the /etc/initramfs-tools/modules file (the format varies depending on the OS).

       [root@CTU10000xxxxx ~]#vi /etc/initramfs-tools/modules
       ......
       # Examples:
       #
       # raid1
       # sd_mOd
       xen-blkfront
       xen-netfront
       virtio_blk
       virtio_scsi
       virtio_net
       virtio_pci
       virtio_ring
       virtio

3. Press Esc, enter :wq, and press Enter. The system saves the change and exits the /etc/initramfs-tools/modules file.
4. Run the following command to regenerate initrd:

   update-initramfs -u

5. Run the following commands to check whether native Xen and KVM drivers have been installed:

   lsinitramfs /boot/initrd.img-`uname -r` |grep xen

   lsinitramfs /boot/initrd.img-`uname -r` |grep virtio

       [root@ CTU10000xxxxx home]# lsinitramfs /boot/initrd.img-`uname -r` |grep xen
       lib/modules/3.5.0-23-generic/kernel/drivers/net/ethernet/qlogic/netxen
       lib/modules/3.5.0-23-generic/kernel/drivers/net/ethernet/qlogic/netxen/netxen_nic.ko
       lib/modules/3.5.0-23-generic/kernel/drivers/net/xen-netback
       lib/modules/3.5.0-23-generic/kernel/drivers/net/xen-netback/xen-netback.ko
       lib/modules/3.5.0-23-generic/kernel/drivers/block/xen-blkback
       lib/modules/3.5.0-23-generic/kernel/drivers/block/xen-blkback/xen-blkback.ko

       [root@ CTU10000xxxxx home]# lsinitramfs /boot/initrd.img-`uname -r` |grep virtio
       lib/modules/3.5.0-23-generic/kernel/drivers/scsi/virtio_scsi.ko

   If you add built-in drivers to the initrd or initramfs file, the ECS will not be affected. This makes it easy to modify the drivers. However, you cannot check the drivers by running the lsinitrd command. You can run the following commands to check whether built-in drivers are in the kernel:

       [root@ CTU10000xxxxx home]# cat /boot/config-`uname -r` | grep CONFIG_VIRTIO | grep y
       CONFIG_VIRTIO_BLK=y
       CONFIG_VIRTIO_NET=y
       CONFIG_VIRTIO=y
       CONFIG_VIRTIO_RING=y
       CONFIG_VIRTIO_PCI=y
       CONFIG_VIRTIO_MMIO_CMDLINE_DEVICES=y
       [root@ CTU10000xxxxx home]# cat /boot/config-`uname -r` | grep CONFIG_XEN | grep y
       CONFIG_XEN_BLKDEV_FRONTEND=y
       CONFIG_XEN_NETDEV_FRONTEND=y

#### SUSE and openSUSE

If the OS version is earlier than SUSE 12 SP1 or openSUSE 13, modify the /etc/sysconfig/kernel file. For details, see scenario 1.

If the OS version is SUSE 12 SP1, modify the /etc/dracut.conf file and add xen-pv and VirtIO drivers. For details, see scenario 2.

If the OS version is later than SUSE 12 SP1 or openSUSE 13, modify the /etc/dracut.conf file and add xen-pv and VirtIO drivers to add_drivers. For details, see scenario 3.

- If the OS version is earlier than SUSE 12 SP1 or openSUSE 13, perform the following steps:

  For SUSE, run the following command to check whether xen-kmp (driver package for xen-pv) is installed in the OS:

  rpm -qa |grep xen-kmp

  If information similar to the following is displayed, xen-kmp is installed:

      xen-kmp-default-4.2.2_04_3.0.76_0.11-0.7.5

  If xen-kmp is not installed, obtain it from the installation ISO and install it first.

  1. Run the following command to open the /etc/sysconfig/kernel file:

     vi etc/sysconfig/kernel

  2. Add the xen-pv and VirtIO drivers after INITRD_MODULES= (the format of drivers depends on the OS).

         SIA10000xxxxx:~ # vi /etc/sysconfig/kernel
         # (like drivers for scsi-controllers, for lvm or reiserfs)
         #
         INITRD_MODULES="ata_piix ata_generic xen_vnif xen_vbd xen_platform_pci virtio_blk virtio_scsi virtio_net virtio_pci virtio_ring virtio"

  3. Run the mkinitrd command to regenerate initrd:

     If the virtual file system is not the default initramfs or initrd, run the dracut -f Name of the initramfs or initrd file actually used command. The actual initramfs or initrd file name can be obtained from the menu.lst or grub.cfg file (/boot/grub/menu.lst, /boot/grub/grub.cfg, or /boot/grub2/grub.cfg).

     The following is an example initrd file of SUSE 11 SP4:

         default 0
         timeout 10
         gfxmenu (hd0,0)/boot/message
         title sles11sp4_001_[_VMX_]
         root (hd0,0)
         kernel /boot/linux.vmx vga=0x314 splash=silent console=ttyS0,115200n8 console=tty0 net.ifnames=0 NON_PERSISTENT_DEVICE_NAMES=1 showopts
         initrd /boot/initrd.vmx
         title Failsafe_sles11sp4_001_[_VMX_]
         root (hd0,0)
         kernel /boot/linux.vmx vga=0x314 splash=silent ide=nodma apm=off noresume edd=off powersaved=off nohz=off highres=off processsor.max+cstate=1 nomodeset x11failsafe console=ttyS0,115200n8 console=tty0 net.ifnames=0 NON_PERSISTENT_DEVICE_NAMES=1 showopts
         initrd /boot/initrd.vmx

     /boot/initrd.vmx in the initrd line is the initrd file actually used. Run the dracut -f /boot/initrd.vmx command. If the initrd file does not contain the /boot directory, such as /initramfs-xxx, run the dracut -f /boot/initramfs-xxx command.

  4. Run the following commands to check whether the PVOPS module for Xen or VirtIO module for KVM is loaded:

     lsinitrd /boot/initrd-`uname -r` | grep xen

     lsinitrd /boot/initrd-`uname -r` | grep virtio

         SIA10000xxxxx:~ # lsinitrd /boot/initrd-`uname -r` | grep xen
         -rwxr--r-- 1 root root 42400 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/block/xen-blkfront.ko
         -rwxr--r-- 1 root root 44200 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/net/xen-netfront.ko

         SIA10000xxxxx:~ # lsinitrd /boot/initrd-`uname -r` | grep virtio
         -rwxr--r-- 1 root root 19248 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/scsi/virtio_scsi.ko
         -rwxr--r-- 1 root root 23856 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/block/virtio_blk.ko
         drwxr-xr-x 2 root root 0 Jul 12 14:53 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio
         -rwxr--r-- 1 root root 15848 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio/virtio_ring.ko
         -rwxr--r-- 1 root root 20008 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio/virtio_pci.ko
         -rwxr--r-- 1 root root 12272 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio/virtio.ko
         -rwxr--r-- 1 root root 38208 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/net/virtio_net.ko

  5. Restart the ECS.
  6. Modify the /boot/grub/menu.lst file. Add xen_platform_pci.dev_unplug=all and modify the root configuration.

     Before the modification:

         ###Don't change this comment -YaST2 identifier: Original name: linux###
         title SUSE Linux Enterprise Server 11SP4 - 3.0.76-0.11 (default)
         root (hd0,0)
         kernel /boot/vmlinuz-3.0.76-0.11-default root=UUID=4eb40294-4c6f-4384-bbb6-b8795bbb1130 splash=silentcrashkernel=256M-:128M showopts vga=0x314
         initrd /boot/initrd-3.0.76-0.11-default

     After the modification:

         ###Don't change this comment -YaST2 identifier: Original name: linux###
         title SUSE Linux Enterprise Server 11SP4 - 3.0.76-0.11 (default)
         root (hd0,0)
         kernel /boot/vmlinuz-3.0.76-0.11-default root=UUID=4eb40294-4c6f-4384-bbb6-b8795bbb1130 splash=silentcrashkernel=256M-:128M showopts vga=0x314 xen_platform_pci.dev_unplug=all
         initrd /boot/initrd-3.0.76-0.11-default

     - Ensure that the root partition is in the UUID format.
     - xen_platform_pci.dev_unplug=all is added to shield QEMU devices.
     - For SUSE 11 SP1 64bit to SUSE 11 SP4 64bit, add xen_platform_pci.dev_unplug=all to the menu.lst file. For SUSE 12 or later, this function is enabled by default, and you do not need to configure it.
  7. Run the following commands to check whether the Xen drivers exist in initrd:

     lsinitrd /boot/initrd-`uname -r` | grep xen

     lsinitrd /boot/initrd-`uname -r` | grep virtio

         SIA10000xxxxx:~ # lsinitrd /boot/initrd-`uname -r` | grep xen
         -rwxr--r-- 1 root root 42400 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/block/xen-blkfront.ko
         -rwxr--r-- 1 root root 44200 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/net/xen-netfront.ko

         SIA10000xxxxx:~ # lsinitrd /boot/initrd-`uname -r` | grep virtio
         -rwxr--r-- 1 root root 19248 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/scsi/virtio_scsi.ko
         -rwxr--r-- 1 root root 23856 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/block/virtio_blk.ko
         drwxr-xr-x 2 root root 0 Jul 12 14:53 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio
         -rwxr--r-- 1 root root 15848 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio/virtio_ring.ko
         -rwxr--r-- 1 root root 20008 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio/virtio_pci.ko
         -rwxr--r-- 1 root root 12272 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/virtio/virtio.ko
         -rwxr--r-- 1 root root 38208 Jun 22 2012 lib/modules/2.6.32-279.el6.x86_64/kernel/drivers/net/virtio_net.ko

     If you add built-in drivers to the initrd or initramfs file, the ECS will not be affected. This makes it easy to modify the drivers. However, you cannot check the drivers by running the lsinitrd command. You can run the following commands to check whether built-in drivers are in the kernel:

     cat /boot/config-`uname -r` | grep CONFIG_VIRTIO | grep y

     cat /boot/config-`uname -r` | grep CONFIG_XEN | grep y

- If the OS version is SUSE 12 SP1, perform the following steps:
  1. Run the following command to open the /etc/dracut.conf file:

     vi /etc/dracut.conf

  2. Press i to enter editing mode and add the xen-pv and VirtIO drivers to add-drivers (the format varies depending on the OS).

         [root@CTU10000xxxxx ~]# vi /etc/dracut.conf
         # additional kernel modules to the default
         add_drivers+="ata_piix ata_generic xen_vnif xen_vbd xen_platform_pci virtio_blk virtio_scsi virtio_net virtio_pci virtio_ring virtio"

  3. Press Esc, enter :wq, and press Enter. The system saves the change and exits the /etc/dracut.conf file.
  4. Run the following command to regenerate initrd:

     dracut -f /boot/initramfs-File name

     If the virtual file system is not the default initramfs, run the dracut -f Name of the initramfs or initrd file actually used command. The actual initramfs or initrd file name can be obtained from the grub.cfg file, which can be /boot/grub/grub.cfg, /boot/grub2/grub.cfg, or /boot/grub/grub.conf depending on the OS.

  5. If the virtual file system is initramfs, run the following commands to check whether native Xen and KVM drivers have been loaded:

     lsinitrd /boot/initramfs-`uname -r`.img | grep xen

     lsinitrd /boot/initramfs-`uname -r`.img | grep virtio

     If the virtual file system is initrd, run the following commands to check whether native Xen and KVM drivers have been loaded:

     lsinitrd /boot/initrd-`uname -r` | grep xen

     lsinitrd /boot/initrd-`uname -r` | grep virtio

- If the OS version is later than SUSE 12 SP1 or openSUSE 13, perform the following steps:
  Take SUSE Linux Enterprise Server 12 SP2 (x86_64) as an example.
  1. Run the following command to open the /etc/dracut.conf file:

     vi /etc/dracut.conf

  2. Press i to enter editing mode and add the xen-pv and VirtIO drivers to add_drivers (the format varies depending on the OS).

         [root@CTU10000xxxxx ~]# vi /etc/dracut.conf
         # additional kernel modules to the default
         add_drivers+="ata_piix ata_generic xen-blkfront xen-netfront virtio_blk virtio_scsi virtio_net virtio_pci virtio_ring virtio"

  3. Press Esc, enter :wq, and press Enter. The system saves the change and exits the /etc/dracut.conf file.
  4. Run the following command to regenerate initrd:

     dracut -f /boot/initramfs-File name

     If the virtual file system is not the default initramfs, run the dracut -f Name of the initramfs or initrd file actually used command. The actual initramfs or initrd file name can be obtained from the grub.cfg file, which can be /boot/grub/grub.cfg, /boot/grub2/grub.cfg, or /boot/grub/grub.conf depending on the OS.

  5. If the virtual file system is initramfs, run the following commands to check whether native Xen and KVM drivers have been loaded:

     lsinitrd /boot/initramfs-`uname -r`.img | grep xen

     lsinitrd /boot/initramfs-`uname -r`.img | grep virtio

     If the virtual file system is initrd, run the following commands to check whether the native Xen and KVM driver modules are successfully loaded:

     lsinitrd /boot/initrd-`uname -r` | grep xen

     lsinitrd /boot/initrd-`uname -r` | grep virtio

     Assume that the virtual file system is initrd. The following command output will be displayed:

         sluo-ecs-30dc:~ # lsinitrd /boot/initrd-`uname -r` | grep xen
         -rw-r--r-- 1 root root 69575 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/block/xen-blkfront.ko
         -rw-r--r-- 1 root root 53415 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/net/xen-netfront.ko
         drwxr-xr-x 2 root root 0 Sep 28 10:21 lib/modules/4.4.21-69-default/updates/pvdriver/xen-hcall
         -rwxr-xr-x 1 root root 8320 Sep 28 10:21 lib/modules/4.4.21-69-default/updates/pvdriver/xen-hcall/xen-hcall.ko

         sluo-ecs-30dc:~ # lsinitrd /boot/initrd-`uname -r` | grep virtio
         -rw-r--r-- 1 root root 29335 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/block/virtio_blk.ko
         -rw-r--r-- 1 root root 57007 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/net/virtio_net.ko
         -rw-r--r-- 1 root root 32415 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/scsi/virtio_scsi.ko
         drwxr-xr-x 2 root root 0 Sep 28 10:21 lib/modules/4.4.21-69-default/kernel/drivers/virtio
         -rw-r--r-- 1 root root 19623 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/virtio/virtio.ko
         -rw-r--r-- 1 root root 38943 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/virtio/virtio_pci.ko
         -rw-r--r-- 1 root root 24431 Oct 26 2016 lib/modules/4.4.21-69-default/kernel/drivers/virtio/virtio_ring.ko

     If you add built-in drivers to the initrd or initramfs file, the ECS will not be affected. This makes it easy to modify the drivers. However, you cannot check the drivers by running the lsinitrd command. You can run the following commands to check whether built-in drivers are in the kernel:

     cat /boot/config-`uname -r` | grep CONFIG_VIRTIO | grep y

     cat /boot/config-`uname -r` | grep CONFIG_XEN | grep y

Parent topic: Image Optimization